Attribute VB_Name = "Module1"
Option Explicit

Public Const WM_MYMSG As Long = &H232
'Dichiarazioni API.
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function CreateDC Lib "Gdi32.dll" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, lpInitData As Long) As Long
Private Declare Function BitBlt Lib "Gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "Gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long
Public IsInit As Boolean



Public Sub CaptureScreen(Frm As Form, Pic As PictureBox)
    'Cattura un'immagine dello schermo.
    Dim hDCscr As Long
    Pic.Cls
    hDCscr = CreateDC("DISPLAY", "", "", 0)
    BitBlt Pic.hdc, 0, 0, Frm.Width, Frm.Height, hDCscr, Frm.Left / Screen.TwipsPerPixelX, Frm.Top / Screen.TwipsPerPixelX, vbSrcErase
    Pic.Refresh
    DeleteDC hDCscr
End Sub
Public Sub GlassForm(Frm As Form)
    'Rende il form trasparente.
    Const RGN_DIFF = 4
    Const RGN_OR = 2
    Dim outer_rgn As Long, inner_rgn As Long
    Dim wid As Single, hgt As Single
    Dim border_width As Single
    Dim title_height As Single
    Dim ctl_left As Single, ctl_top As Single, ctl_right As Single, ctl_bottom As Single
    Dim control_rgn As Long, combined_rgn As Long
    Dim ctl As Control
    If Frm.WindowState = vbMinimized Then Exit Sub
    wid = Frm.ScaleX(Frm.Width, vbTwips, vbPixels)
    hgt = Frm.ScaleY(Frm.Height, vbTwips, vbPixels)
    outer_rgn = CreateRectRgn(0, 0, wid, hgt)
    border_width = (wid - Frm.ScaleWidth) / 2
    title_height = hgt - border_width - Frm.ScaleHeight
    inner_rgn = CreateRectRgn(border_width, title_height, wid - border_width, hgt - border_width)
    combined_rgn = CreateRectRgn(0, 0, 0, 0)
    CombineRgn combined_rgn, outer_rgn, inner_rgn, RGN_DIFF
    For Each ctl In Frm.Controls
        With ctl
            If .Container Is Frm Then
                ctl_left = Frm.ScaleX(.Left, Frm.ScaleMode, vbPixels) + border_width
                ctl_top = Frm.ScaleX(.Top, Frm.ScaleMode, vbPixels) + title_height
                ctl_right = Frm.ScaleX(.Width, Frm.ScaleMode, vbPixels) + ctl_left
                ctl_bottom = Frm.ScaleX(.Height, Frm.ScaleMode, vbPixels) + ctl_top
                control_rgn = CreateRectRgn(ctl_left, ctl_top, ctl_right, ctl_bottom)
                CombineRgn combined_rgn, combined_rgn, control_rgn, RGN_OR
            End If
        End With
    Next ctl
    SetWindowRgn Frm.hwnd, combined_rgn, True
End Sub
Public Sub Init(ShadowFrm As Form, Frm As Form, iLeft As Integer, iTop As Integer, iWidth As Integer, iHeight As Integer)
    Dim IsLoad As Boolean
    
    On Error Resume Next
    
    With ShadowFrm
        .Visible = False
        .ScaleMode = 3  'Pixel
        .Left = iLeft + 90
        .Top = iTop + 90
        .Width = iWidth
        .Height = iHeight
    
        CaptureScreen ShadowFrm, ShadowFrm.picShadow
        Sleep 20
        .Visible = True
    End With
    frmWShade.ZOrder 0
End Sub

Sub Main()
    frmTest.Show
    
End Sub


